#include <cyg/hal/hal_intr.h>

#if defined(SDRAM_0_BASE) && defined(SDRAM_0_SPAN) && defined(CYGPKG_COMTROL_DM2_FLASH)
 #define LoadableStart (SDRAM_0_BASE)
 #define LoadableEnd   (SDRAM_0_BASE+SDRAM_0_SPAN-0x80000)
#elif defined(CYGPKG_HAL_ARM_DMRTS)
 #include <pkgconf/mlt_arm_dmrts_ram_RedBoot.h>
 #define LoadableStart 0x00000000
 #define LoadableEnd   CYGMEM_REGION_ram_SIZE
#else
 #error "Don't know where target RAM is"
#endif

#define ValidRam(start,len) (((start) >= LoadableStart) && (((start)+(len)) <= LoadableEnd))

#if defined(CYGPKG_HAL_NIOS2)
  extern cyg_uint32 DM2WatchdogRegShadow;
  #define WatchdogReg ((cyg_uint32*)0x20018f0)
  #define ControlReg  ((cyg_uint32*)0x2001850)
  #define WatchdogEnable()  __builtin_stwio(ControlReg, __builtin_ldwio(ControlReg) | 1)
  #define WatchdogDisable() __builtin_stwio(ControlReg,  __builtin_ldwio(ControlReg) & ~1)
  #define WatchdogKick __builtin_stwio(WatchdogReg, DM2WatchdogRegShadow ^= 1)
  #define DM_BOARD_RESET() do{WatchdogEnable(); while(1) /*wait*/; }while(1)
#else
  #include <cyg/hal/plf_stub.h>
  #define DM_BOARD_RESET()  do {HAL_STUB_PLATFORM_RESET();}while(0)
#endif
