#ifndef _IDENT_H
#define _IDENT_H

#define printf diag_printf

/*  The following define the data fields of the packets used in MAC mode */

/*  This is the Ethernet protocol ID used by Comtrol.  */
#define ETH_P_COMTROL	0x11FE

/* Product ID's */
#define RPSHSI_ID	0xAA

/* Packet classes */
#define ADMIN_CLASS	0x01
#define RPSHSI_CLASS	0x55

/* These are the various ADMIN packet types */
#define ADMIN_SEC_LOAD_TYPE	1
#define ADMIN_PRD_ID_REQ_TYPE	2
#define ADMIN_PRD_ID_REP_TYPE	3
#define ADMIN_LOOPBACK_TYPE	4
#define ADMIN_RESET_TYPE	5

/*  Error states for the loopback test */
#define LOOP_PASS                 0
#define LOOP_ERROR                0x10000
#define LOOP_CHANNEL_STATUS_ERROR 0x20000
#define LOOP_DATA_VERIFY_ERROR    0x30000
#define LOOP_CTS_NOT_RTS          0x50000
#define LOOP_NO_CTS_EVENT         0x50001
#define LOOP_RI_NOT_RTS           0x60000
#define LOOP_DSR_NOT_DTR          0x70000
#define LOOP_CD_NOT_DTR           0x80000
#define LOOP_TIMEOUT              0x90000
#define LOOP_MODE_NOT_SUPPORTED   0xA0000

/*  Time in seconds to wait for a reponse to an attempt to close the TCP socket. */
#define TCP_SOCKET_CLOSE_TIMEOUT 20          

typedef struct
{
  unsigned long   modelId;
#if defined(CYGPKG_HAL_NIOS2)
  unsigned long   serNumDM2;
  unsigned short  serNumPrefixDM2;
#endif
  unsigned short  programId;
  unsigned char   archId;
  unsigned long   boardRev;
  unsigned char   numPorts;
  unsigned char   versionMajor;
  unsigned char   versionMinor;
  unsigned long   ipAddr;
  unsigned long   netMask;
  unsigned long   gateway;
  unsigned char   macAddr[6];
  unsigned char   password[16];
  unsigned char   authMethod;
  unsigned char   telnetEnable;
  unsigned char   secureDataEnable;
  unsigned char   secureConfigEnable;
  unsigned char   snmpEnable;
  unsigned char	  dhcpEnable;
  unsigned char   timeoutValue;
  unsigned long   telnetTimeout;
  unsigned char   appEnblKey;
} tIdent;
#define UP_ENABLE_FLAG 0x01     // HBB - new 12/07/05

extern tIdent ident;

extern char IdentString[];	//??was 64

void putIpInfo(unsigned long ipAddr, unsigned long netMask, unsigned long gateway);
void getIpInfo(unsigned long *ipAddr, unsigned long *netMask, unsigned long *gateway);

extern int disableAutoload;
extern int disableDriverload;

extern void loadStatusInit(void);
extern void loadStatusUpdate(unsigned long addr, unsigned len);
extern void loadStatusShow(void);
extern cyg_uint32 getFeatureBits(void);

#endif // _IDENT_H
