#include "std.h"
#include "ks5000_regs.h"
#include "phy.h"

#define	PHY_CNTL_REG 	0x00
#define	PHY_STATUS_REG 	0x01
#define	PHY_ID_REG1    	0x02
#define	PHY_ID_REG2    	0x03
#define	PHY_ANA_REG    	0x04
#define	PHY_ANLPAR_REG 	0x05
#define	PHY_ANE_REG    	0x06
#define	PHY_ECNTL_REG1 	0x10
#define	PHY_QPDS_REG   	0x11
#define	PHY_10BOP_REG  	0x12
#define	PHY_ECNTL_REG2 	0x13

#define Bit(n) (1<<(n))

#define RESET_PHY	Bit(15)
#define ENABLE_LOOPBACK	Bit(14)
#define DR_100MB	Bit(13)
#define ENABLE_AN	Bit(12)
#define PHY_MAC_ISOLATE	Bit(10)
#define RESTART_AN	Bit(9)
#define PHY_FULLDUPLEX	Bit(8)
#define PHY_COL_TEST	Bit(7)

void ResetPhyChip(void)
{
    MiiStationWrite(PHY_CNTL_REG, RESET_PHY ) ;
    MiiStationWrite(PHY_CNTL_REG, ENABLE_AN | RESTART_AN) ;
}

unsigned PhyStatus(void)
{
    unsigned status = MiiStationRead(PHY_QPDS_REG);
    unsigned r = 0;
    if (status & Bit(0))
        r |= PhyStatus_LinkUp;
    if (status & Bit(14))
        r |= PhyStatus_FullDuplex;
    if (status & Bit(15))
        r |=  PhyStatus_100Mb;
    return r;
}

void PhyInterruptAck(void)
{
}

