#ifndef _ICS1893_H
#define _ICS1893_H

#define Bit(n) (1<<(n))

//for polling loop
#ifndef TICKS_PER_SECOND
#define TICKS_PER_SECOND 100
#endif

#ifndef cyg_thread_delay_ms
#define cyg_thread_delay_ms(n) cyg_thread_delay(n/(1000/TICKS_PER_SECOND))
#endif

#define	ICS_PHY_CNTL_REG			0
#define	ICS_PHY_STATUS_REG			1
#define	ICS_PHY_ID_REG1				2
#define	ICS_PHY_ID_REG2				3
#define	ICS_PHY_AUTONEG_REG			4
#define	ICS_PHY_AUTONEGLPA_REG		5
#define	ICS_PHY_AUTONEGEXP_REG		6
#define	ICS_PHY_AUTONEGNPT_REG		7
#define	ICS_PHY_AUTONEGNPLPA_REG	8
#define	ICS_PHY_QPDSTATUS_REG   	17
#define	ICS_PHY_10BTOPS_REG			18
#define	ICS_PHY_ECNTL_REG1			16
#define	ICS_PHY_ECNTL_REG2			19

// 1 = on , 0 = off
#define ICS_R0_RESET_PHY			Bit(15)
#define ICS_R0_ENABLE_LOOPBACK		Bit(14)		//default = 0
#define ICS_R0_DATARATE_100MB		Bit(13)		//0 = 10MB, default = 1
#define ICS_R0_ENABLE_AUTONEG		Bit(12)		//auto-negotiation, default = 1
#define ICS_R0_PHY_MAC_ISOLATE		Bit(10)		//when R16.10:6 is empty value is 00000
#define ICS_R0_RESTART_AUTONEG		Bit(9)
#define ICS_R0_PHY_FULLDUPLEX		Bit(8)		//default = 0
#define ICS_R0_PHY_COL_TEST			Bit(7)


//use the Quick Poll Detailed Status Register (0x17 = ICS_PHY_QPDSTATUS_REG)
#define ICS_PHY_QPDSTAT_LINK_UP			Bit(0)	//1 = is up
#define ICS_PHY_QPDSTAT_REMOTE_FAULT	Bit(1)	//1 = remote error
#define ICS_PHY_QPDSTAT_AUTONEG			Bit(4)	//1 = done
#define ICS_PHY_QPDSTAT_SIG_LOST		Bit(10)	//100TX signal lost
#define ICS_PHY_QPDSTAT_FULL_DUPLEX		Bit(14)	//1 = full
#define ICS_PHY_QPDSTAT_100MB			Bit(15)	//1 = full

//use the Quick Poll Detailed Status Register (0x17 = ICS_PHY_QPDSTATUS_REG)
#define ICS_PHY_R1_STAT_JABR				Bit(1)
#define ICS_PHY_R1_STAT_LINK_UP				Bit(2)
#define ICS_PHY_R1_STAT_REMOTEFAULT			Bit(4)
#define ICS_PHY_R1_STAT_AUTONEGDONE			Bit(5)
#define ICS_PHY_R1_STAT_MFPREREQ			Bit(6)
#define ICS_PHY_R1_STAT_10BTHSUPP			Bit(11)
#define ICS_PHY_R1_STAT_10BTFSUPP			Bit(12)
#define ICS_PHY_R1_STAT_100BTXHSUPP			Bit(13)
#define ICS_PHY_R1_STAT_100BTXFSUPP			Bit(14)

int ics_is100MB(void);
int ics_isfullduplexed(void);
int ics_islinkup(void);

void ics_reset_phy(void);
void ics_restart_autonegotiation(void);
void ics_waitfor_autonegotiation(void);
void ics_phy_status(void);
void ics_init(void);
void ics_set_fullduplex(int val);	//send in a 0 or 1 only

unsigned ics_phy_R0_state(void);
unsigned ics_phy_R1_state(void);
unsigned ics_phy_qpd_state(void);

#endif
