/*
 *  dm2.c  pieces pulled from rocket2.c in rp infinity driver and orig dmrts.c
 *
 *   Top level function for Nserial driver for DeviceMaster DM2.   
 *   The DM2  either uses the UNITY for it's serial
 *   ports UART.  This driver calls the correct handler functions.          
 *****************************************************88888******************/


#include <pkgconf/io_nserial.h>	//from dmrts.c
#include <pkgconf/io.h>
#include <cyg/io/io.h>
#include <cyg/hal/hal_intr.h>
#include <cyg/io/devtab.h>
#include <cyg/io/serial.h>
#include <cyg/io/serialio.h>
#include <cyg/infra/diag.h>

#include "unity.h"
#include "dm2.h"

#if 1
#define debug_printf(args...) diag_printf(args)
#else
#define debug_printf(args...) /* noop */
#endif

#include <cyg/kernel/kapi.h>


//  Define the serial handler functions
serial_channel serialChannel[32];

//  Create the eCos devices /dev/ser0 - /dev/ser31
#define DevTabEntry(n) \
   DEVTAB_ENTRY(dm2_serial_io##n,\
   "/dev/ser" #n,\
   0,\
   &cyg_io_serial_devio,\
   unity_serial_init,\
   unity_serial_lookup,\
   &serialChannel[n])

DevTabEntry(0);
DevTabEntry(1);
DevTabEntry(2);
DevTabEntry(3);
DevTabEntry(4);
DevTabEntry(5);
DevTabEntry(6);
DevTabEntry(7);
DevTabEntry(8);
DevTabEntry(9);
DevTabEntry(10);
DevTabEntry(11);
DevTabEntry(12);
DevTabEntry(13);
DevTabEntry(14);
DevTabEntry(15);
DevTabEntry(16);
DevTabEntry(17);
DevTabEntry(18);
DevTabEntry(19);
DevTabEntry(20);
DevTabEntry(21);
DevTabEntry(22);
DevTabEntry(23);
DevTabEntry(24);
DevTabEntry(25);
DevTabEntry(26);
DevTabEntry(27);
DevTabEntry(28);
DevTabEntry(29);
DevTabEntry(30);
DevTabEntry(31);


unsigned long select_baud[] = 
{
  0,
  50,
  75,
  110,
  134,
  150,
  200,
  300,
  600,
  1200,
  1800,
  2400,
  3600,
  4800,
  7200,
  9600,
  14400,
  19200,
  38400,
  57600,
  115200,
  230400,
  460800
};

