/*
 * dm2.h --- Include file for dm2.c.
 */

#ifndef _DM2_H
#define _DM2_H

//  Defines the buffer sizes for each port (2 buffers per)
#define BufSize 4096	//aiopic

#ifndef MIN
#define MIN(a,b)	((a) < (b) ? (a) : (b))
#endif

#define MAX_NUMBEROF_UNITIES   2
#define MAX_NUMBEROF_PORTS    32

/*  Flow control defines  */
#define FLOW_CONTROL_NONE    0
#define FLOW_CONTROL_RTSCTS  1
#define FLOW_CONTROL_XONXOFF 2
#define FLOW_CONTROL_DTRDSR  3

#define DISABLED_MODE  0x00	//start up condition
#define RS232_MODE     0x01
#define RS422_MODE     0x02
#define RS485FD_MODE   0x03
#define RS485HD_MODE   0x04
#define RS485TST_MODE  0x05
#define RESERVED_MODE  0x06
#define DEBUG_MODE     0x07	//chan 0 only

#define DEFAULT_PRESCALE  0

/*  Prototypes */	//from aiop renamed dmrts to dm2
bool dm2_serial_init(struct cyg_devtab_entry *tab);
Cyg_ErrNo dm2_serial_lookup(struct cyg_devtab_entry **tab,  struct cyg_devtab_entry *sub_tab,  const char *name);

#include "unity.h"

/* Unity (was Controller) level information structure */
typedef struct {
  	int numPorts;                                 /*  Number of channels (serial ports) */

         /*  Model information */
	int clockPrescale;
	int has_2nd_asic;
		//	tChan channel[MAX_NUMBEROF_PORTS];       /*  One channel structure per serial port */
		//	CHANNEL_T channel[MAX_NUMBEROF_PORTS];       /*  One channel structure per serial port */
	void *pBasePciRegion0;               //  Base memory address region 0
	void *pBasePciMemory;                //  Base memory address region 1
} tUnity;		//} CONTROLLER_T;




extern unsigned long select_baud[]; 
extern serial_channel serialChannel[32];
extern serial_funs dm2_serial_functions;

#endif // _DM2_H
