/***************************************************************/
/*       dmrts.h                                              */
/*                                                             */
/*       Include file for dmrts.c                             */
/***************************************************************/

#ifndef _DMRTS_H
#define _DMRTS_H


//  Defines the buffer sizes for each port (2 buffers per)
#define BufSize 4096

#define RS232_MODE  0x00
#define RS232I_MODE 0x18
#define RS422_MODE  0x08
#define RS485_MODE  0x10
#define RS485FDS    0x48    // Available on DM RTS 2P only
#define RS485FDM    0x08    // Available on DM RTS 2P only
#define RSMode_Diag         0x50    // Available on DM RTS 2P only, port 0 only
#define RSMode_485TEST      0x58    // Available on DM RTS 2P only
/*  Prototypes */
bool dmrts_serial_init(struct cyg_devtab_entry *tab);
Cyg_ErrNo dmrts_serial_lookup(struct cyg_devtab_entry **tab,  struct cyg_devtab_entry *sub_tab,  const char *name);

/*  Timer related structs */
typedef volatile unsigned int reg;
typedef struct
{
  reg tmod;      // Timer mode
  reg tdata0;    // Timer 0 Data
  reg tdata1;    // Timer 1 Data
  reg tcnt0;     // Timer 0 Count
  reg tcnt1;     // Timer 1 Count
}tTimers;

#define TimerModeEnable0  Bit(0)
#define TimerModeToggle0  Bit(1)
#define TimerModeInitOut0 Bit(2)
#define TimerModeEnable1  Bit(3)
#define TimerModeToggle1  Bit(4)
#define TimerModeInitOut1 Bit(5)

extern volatile tTimers ks32c5000_timer;

void timerSetup(unsigned period);

extern unsigned long select_baud[]; 
extern serial_channel serialChannel[32];
extern serial_funs dmrts_serial_functions;

#endif // _DMRTS_H
